## tuxmake-0.25.0.tar.gz

=== Makefile ===
.PHONY: test tags dist

export PROJECT := tuxmake

ALL_TESTS_PASSED = ======================== All tests passed ========================

all: typecheck codespell style unit-tests integration-tests docker-build-tests man doc bash_completion
	@printf "\033[01;32m$(ALL_TESTS_PASSED)\033[m\n"


unit-tests:
	python3 -m pytest --cov=tuxmake --cov-report=term-missing --cov-fail-under=100 test

style:
	black --check --diff .
	flake8 .

typecheck:
	mypy tuxmake

codespell:
	codespell \
		--check-filenames \
		--skip '.git,public,dist,*.sw*,*.pyc,tags,*.json,.coverage,htmlcov'

RUN_TESTS = scripts/run-tests

integration-tests:
	$(RUN_TESTS) test/integration

integration-tests-docker:
	$(RUN_TESTS) test/integration-slow/docker*

docker-build-tests:
	$(MAKE) -C support/docker test

release:
	./scripts/release $(V)

man: tuxmake.1

tuxmake.1: tuxmake.rst cli_options.rst
	rst2man tuxmake.rst $@

bash_completion: bash_completion/tuxmake

bash_completion/tuxmake: tuxmake/cmdline.py $(wildcard tuxmake/*/*.ini)
	mkdir -p $$(dirname $@)
	python3 -m tuxmake.cmdline bash_completion > $@ || ($(RM) $@; false)

cli_options.rst: tuxmake/cli.py scripts/cli2rst.sh tuxmake/cmdline.py
	scripts/cli2rst.sh $@

docs/cli.md: tuxmake.rst tuxmake/cli.py scripts/cli2md.sh scripts/cli2md.py
	scripts/cli2md.sh $@

docs/index.md: README.md scripts/readme2index.sh
	scripts/readme2index.sh $@

doc: public

public: docs/cli.md docs/index.md $(wildcard docs/*)
	python3 -m pytest scripts/test_doc.py
	PYTHONPATH=. mkdocs build

serve-public: public
	mkdocs serve --livereload --strict

tags:
	ctags --exclude=public --exclude=.mypy_cache --exclude=tmp -R

clean:
	$(RM) -r tuxmake.1 cli_options.rst docs/cli.md docs/index.md public/ tags dist/ bash_completion/

version = $(shell sed -e '/^__version__/ !d; s/"\s*$$//; s/.*"//' tuxmake/__init__.py)

rpm: dist/tuxmake-$(version)-0tuxmake.noarch.rpm

RPMBUILD = rpmbuild
dist/tuxmake-$(version)-0tuxmake.noarch.rpm: dist/tuxmake-$(version).tar.gz dist/tuxmake.spec
	cd dist && \
	$(RPMBUILD) -ta --define "dist tuxmake" --define "_rpmdir $$(pwd)" tuxmake-$(version).tar.gz
	mv $(patsubst dist/%, dist/noarch/%, $@) $@
	rmdir dist/noarch

rpmsrc: dist dist/tuxmake.spec

dist/tuxmake.spec: tuxmake.spec
	cp tuxmake.spec dist/

dist: dist/tuxmake-$(version).tar.gz

dist/tuxmake-$(version).tar.gz:
	flit build

deb: debsrc dist/tuxmake_$(version)-1_all.deb

dist/tuxmake_$(version)-1_all.deb: dist/tuxmake_$(version)-1.dsc
	cd dist/tuxmake-$(version) && dpkg-buildpackage -b -us -uc

debsrc: dist dist/tuxmake_$(version)-1.dsc dist/tuxmake_$(version).orig.tar.gz

dist/tuxmake_$(version).orig.tar.gz: dist/tuxmake-$(version).tar.gz
	ln -f $< $@

dist/tuxmake_$(version)-1.dsc: dist/tuxmake_$(version).orig.tar.gz $(wildcard debian/*)
	cd dist && tar xaf tuxmake_$(version).orig.tar.gz
	cp -r debian/ dist/tuxmake-$(version)
	cd dist/tuxmake-$(version)/ && dpkg-buildpackage -S -d -us -uc

=== support/docker/Makefile ===
export PYTHONPATH := $(shell readlink -f $(CURDIR)/../..)
REGISTRY := docker.io/
PROJECT := tuxmake

ANN := echo
ifneq ($(findstring s,$(filter-out --%,$(MAKEFLAGS))),)
  ANN := true
endif

ifeq ($(V), 1)
Q         :=
LOG       :=
ANN       := true
NOSTDOUT  :=
else
Q         := @
LOG       := > log/$@.log 2>&1 || (cat log/$@.log; false)
NOSTDOUT  := > /dev/null
endif

ANN_BUILD := @$(ANN) " BUILD"
ANN_TEST  := @$(ANN) "  TEST"

docker := docker

default: checkconfig all
	@$(MAKE) --silent show

checkconfig:
	@if [ ! -f configure.mk ]; then echo "configure.mk not found; run ./configure first"; false; fi

-include configure.mk
-include configure.local.mk

noop_releases = $(patsubst %, noop-%, $(releases))
publish_releases = $(patsubst %, publish-%, $(releases))
test_releases = $(patsubst %, test-%, $(releases))
publish_multiarch_releases = $(patsubst %, publish-multiarch-%, $(releases))

$(noop_releases):

log:
	mkdir $@

ifneq ($(findstring s,$(filter-out --%,$(MAKEFLAGS))),)
xargs = xargs -r
else
xargs = xargs -r -t
endif

$(publish_releases): publish-%: test-%
	images=$$(./list-images $*); \
	if [ "x$$images" != x ]; then \
	  echo $(patsubst %, $(PROJECT)/%:latest$(TAG), $(shell ./list-images $*)) | \
	    $(xargs) -n 1 $(docker) push; \
	fi

$(test_releases): test-%: Makefile
	  @list="$(patsubst %, test-%, $(shell ./list-images $*))"; if [ -n "$$list" ]; then $(MAKE) $$list; fi

TIMESTAMP = $(shell date +%Y%m%d)

$(publish_multiarch_releases): publish-multiarch-%: noop-%
	@for image in $(shell ./list-images $*); do \
		echo $(PROJECT)/$${image}:$(TIMESTAMP) $$(./get-arch-images $${image}) | \
			$(xargs) $(docker) manifest create; \
		echo $(PROJECT)/$${image}:latest-dev $$(./get-arch-images $${image}) | \
			$(xargs) $(docker) manifest create; \
		echo $(PROJECT)/$${image}:latest $$(./get-arch-images $${image}) | \
			$(xargs) $(docker) manifest create; \
	done
	@echo $(patsubst %, $(PROJECT)/%:$(TIMESTAMP), $(shell ./list-images $*)) | \
		$(xargs) -n 1 $(docker) manifest push
	@echo $(patsubst %, $(PROJECT)/%:latest-dev, $(shell ./list-images $*)) | \
		$(xargs) -n 1 $(docker) manifest push
	@echo $(patsubst %, $(PROJECT)/%:latest, $(shell ./list-images $*)) | \
		$(xargs) -n 1 $(docker) manifest push


test:
	sh test/test_configure.sh
	sh test/test_gitlab_ci.sh

test-images: $(patsubst %, test-%, $(all_images))

SMOKE_ARCH = x86_64 arm64
SMOKE_TOOLCHAINS = gcc gcc-8 gcc-9 gcc-10 gcc-11 clang-11 clang-12 clang-nightly clang-android
SMOKE_IMAGES = $(foreach toolchain,$(SMOKE_TOOLCHAINS),test-$(toolchain) $(foreach arch,$(SMOKE_ARCH),test-$(arch)_$(toolchain)))
smoke-test: test-base-debian10 test-base-debian11 test-base-debiantesting $(SMOKE_IMAGES)

show:
	@$(docker) images $(PROJECT)/\* | sed -e 1d | sort

clean:
	$(RM) configure.mk
	$(RM) -r log/

purge:
	$(docker) image ls --format='{{.Repository}}:{{.Tag}}' $(PROJECT)/\* \
		| xargs $(docker) rmi

dot:
	@(echo "digraph images {"; sed -e '/# dot:/!d; s/^# dot: //' configure.mk; echo "}")

.PHONY: $(all_images) $(releases) $(publish_releases) $(publish_multiarch_releases) test show list clean purge dot

gitlab-ci.yml: gen-gitlab-ci ../../tuxmake/runtime/docker.ini
	+./gen-gitlab-ci > $@ || ($(RM) $@; false)

=== test/fakelinux/Makefile ===
SRC = $(CURDIR)
O ?= $(CURDIR)
ARCH ?= $(shell basename $$(readlink -f $(SRC)/arch/$$(uname -m).mk) .mk)
VERSION := $(shell uname -r)

ifeq ($(LLVM), )
HOSTCC = gcc
CC     = $(CROSS_COMPILE)gcc
LD     = $(CROSS_COMPILE)ld
else
HOSTCC = clang
CC     = clang
LD     = ld.lld
endif

CFLAGS += -nostdlib
ifneq ($(CROSS_COMPILE),)
ifneq ($(shell $(CC) --version 2>&1 | head -n1 | grep clang),)
triplet := $(patsubst %-,%,$(CROSS_COMPILE))
CFLAGS += --target=$(triplet)
endif
endif

KBUILD_BUILD_TIMESTAMP ?= $(shell LANG=C date)
KBUILD_BUILD_USER ?= $(shell whoami)
KBUILD_BUILD_HOST ?= $(shell hostname)

CFLAGS += -DSOURCE_DATE_EPOCH=$(shell date -d "$(KBUILD_BUILD_TIMESTAMP)" +%s)
CFLAGS += -DKBUILD_BUILD_TIMESTAMP='"$(KBUILD_BUILD_TIMESTAMP)"'
CFLAGS += -DKBUILD_BUILD_USER='"$(KBUILD_BUILD_USER)"'
CFLAGS += -DKBUILD_BUILD_HOST='"$(KBUILD_BUILD_HOST)"'

all:

include arch/$(ARCH).mk
ARCHDIRNAME ?= $(ARCH)

.PHONY: config vmlinux $(IMAGE) modules modules_install dtbs dtbs_install targz-pkg

all: vmlinux $(IMAGE)

kernelversion:
	$(call maybefail,kernelversion)
	@echo $(VERSION)

define maybefail
	@if [ "$(filter $(1),$(FAIL))" = "$(1)" ]; then echo "error: target $(1) failed" >&2; exit 1; fi
	@if [ "$(filter $(1),$(WARN))" = "$(1)" ]; then echo "warning: target $(1) has some issues" >&2; fi
endef


########################################################################
# final kernel image
#########################################################################
$(IMAGE): $(O)/arch/$(ARCHDIRNAME)/boot/$(IMAGE)
CLEAN += $(O)/arch/$(ARCHDIRNAME)/boot/$(IMAGE)
$(O)/arch/$(ARCHDIRNAME)/boot/$(IMAGE): $(O)/vmlinux
	$(call maybefail,kernel)
	mkdir -p $$(dirname $@)
	$(COMPRESS) < $< > $@ || ($(RM) $@; false)


########################################################################
# alternative image
########################################################################
ifneq (,$(ALT_IMAGE))
$(ALT_IMAGE): $(O)/arch/$(ARCHDIRNAME)/boot/$(ALT_IMAGE)
CLEAN += $(O)/arch/$(ARCHDIRNAME)/boot/$(ALT_IMAGE)
$(O)/arch/$(ARCHDIRNAME)/boot/$(ALT_IMAGE): $(O)/vmlinux
	$(call maybefail,kernel)
	mkdir -p $$(dirname $@)
	$(ALT_COMPRESS) < $< > $@ || ($(RM) $@; false)
endif


########################################################################
# debug kernel image
########################################################################
vmlinux: $(O)/vmlinux
CLEAN += $(O)/vmlinux
CLEAN += $(O)/System.map
$(O)/vmlinux: $(O)/.config
$(O)/vmlinux: $(O)/vmlinux.o
	$(call maybefail,debugkernel)
	$(LD) -o $@ $<
	@echo SYSMAP System.map
	@printf "c1000000 T _text\n0000000000000000 D __per_cpu_start\n0000000000000000 D fixed_percpu_data\n" \
		> $(O)/System.map

CLEAN += $(O)/vmlinux.o
$(O)/vmlinux.o: vmlinux.c
	$(CC) $(CFLAGS) -c -o $@ $<

########################################################################
# headers
########################################################################

INSTALL_HDR_PATH ?= ./usr
headers_install:
	mkdir -p $(INSTALL_HDR_PATH)/include/linux
	touch $(INSTALL_HDR_PATH)/include/linux/atomic.h

########################################################################
# XIP kernel image
########################################################################

CLEAN += $(O)/arch/$(ARCHDIRNAME)/boot/xipImage
xipImage: $(O)/arch/$(ARCHDIRNAME)/boot/xipImage
$(O)/arch/$(ARCHDIRNAME)/boot/xipImage: $(O)/vmlinux
	$(call maybefail,xipImage)
	@grep -q CONFIG_XIP_KERNEL=y $(O)/.config || (echo "Error: CONFIG_XIP_KERNEL not set"; false)
	cp $(O)/vmlinux $@


########################################################################
# modules
#########################################################################
modules: $(O)/modules
CLEAN += $(O)/modules
$(O)/modules: $(O)/vmlinux
	$(call maybefail,modules)
	mkdir -p $@/lib/modules/$(VERSION)/kernel/fs/ext4
	touch    $@/lib/modules/$(VERSION)/kernel/fs/ext4/ext4.ko

modules_install: $(O)/modules
	mkdir -p $(INSTALL_MOD_PATH)
	cp -r $(O)/modules/lib $(INSTALL_MOD_PATH)/


########################################################################
# dtbs
########################################################################
DTBSDIR= arch/$(ARCHDIRNAME)/boot/dts
DTBS = $(O)/$(DTBSDIR)
CLEAN += $(DTBS)/hisilicon

$(DTBS): $(DTBSDIR)
	mkdir -p $@

dtbs: $(O)/.config $(DTBS)
	$(call maybefail,dtbs)
	mkdir -p $(DTBS)/hisilicon
	touch    $(DTBS)/hisilicon/hi6220-hikey.dtb

dtbs_install: $(DTBS)
	mkdir -p $(INSTALL_DTBS_PATH)
	cp -r $(DTBS)/* $(INSTALL_DTBS_PATH)/


########################################################################
# configuration
########################################################################
config: $(O)/scripts/kconfig/config
CLEAN += $(O)/scripts/kconfig/config
$(O)/scripts/kconfig/config: scripts/kconfig/config.c
	mkdir -p $$(dirname $@)
	$(HOSTCC) -o $@ $<

defconfig: config
	$(call maybefail,defconfig)
	mkdir -p $(O)
	echo 'CONFIG_MODULES=y' > $(O)/.config

olddefconfig: config
	$(call maybefail,olddefconfig)
	test -f $(O)/.config

tinyconfig: config
	$(call maybefail,tinyconfig)
	mkdir -p $(O)
	echo '# CONFIG_MODULES is not set' > $(O)/.config

kvm_guest.config: config
	$(call maybefail,kvm_guest.config)
	echo CONFIG_KVM_GUEST=y >> $(O)/.config

qemu-gdb.config: config
	$(call maybefail,qemu-gdb.config)
	echo CONFIG_DEBUG_INFO=y >> $(O)/.config

########################################################################
# targz-pkg: very loosely based on linux/scripts/package/buildtar
########################################################################
KERNELRELEASE = 5.13.0-rc3
tmpdir = $(O)/tar-install
tarball = $(O)/linux-$(KERNELRELEASE)-$(ARCHDIRNAME).tar.gz
dirs = boot
CLEAN += $(tarball)
targz-pkg: all
	mkdir -p -- $(tmpdir)/boot
	cp -v -- $(O)/System.map $(tmpdir)/boot/System.map-$(KERNELRELEASE)
	cp -v -- Kconfig $(tmpdir)/boot/config-$(KERNELRELEASE)
	cp -v -- $(O)/vmlinux $(tmpdir)/boot/vmlinux-$(KERNELRELEASE)
	cp -v -- $(O)/arch/$(ARCHDIRNAME)/boot/$(IMAGE) $(tmpdir)/boot/vmlinuz-$(KERNELRELEASE)

	tar zcf $(tarball) -C $(tmpdir) $(dirs)
	echo "Tarball successfully created in $(tarball)"

########################################################################
# cleaning
########################################################################
clean:
	$(RM) -rf $(CLEAN)

distclean: clean
	$(RM) $(O)/.config

=== debian/changelog ===
tuxmake (0.25.0-1) UNRELEASED; urgency=medium

  * Initial release

 -- Antonio Terceiro <antonio.terceiro@linaro.org>  Wed, 23 Dec 2020 17:26:49 -0300

=== debian/control ===
Source: tuxmake
Maintainer: Antonio Terceiro <antonio.terceiro@linaro.org>
Section: python
Priority: optional
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               dh-python,
               flit,
               git,
               wget,
               python3-all,
               python3-pytest,
               python3-pytest-cov,
               python3-pytest-mock
Standards-Version: 3.9.6
Homepage: https://tuxmake.org/

Package: tuxmake
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}, python3 (>= 3.6), ${python3:Depends}
Recommends: socat
Description: Thin wrapper to build Linux kernels
 TuxMake is a command line tool and Python library that provides portable and
 repeatable Linux kernel builds across a variety of architectures, toolchains,
 kernel configurations, and make targets.
